﻿#pragma once

enum LOG_LEVEL
{
	 LOG_LEVEL_DEBUG = 0			//デバッグなどに必要な情報。
	,LOG_LEVEL_NOTIFY = 3			//通知
	,LOG_LEVEL_ERROR = 9			//エラー
};

#define LOGOUT(LOGTYPE,LOGMESSAGE) {\
	if ( (int)(LOGTYPE) >= (int)(MainWindow::m()->Logger.getLevel()) ) { \
		std::stringstream LOGOUTSTREAM; \
		LOGOUTSTREAM << LOGTYPE << "\t" << __FUNCTION__ << ":" << __LINE__ << "\t" << LOGMESSAGE; \
		MainWindow::m()->Logger.Write(LOGOUTSTREAM.str() );\
	} \
}
#define DEBUGLOG(LOGMESSAGE)  LOGOUT(LOG_LEVEL_DEBUG,LOGMESSAGE)
#define NOTIFYLOG(LOGMESSAGE) LOGOUT(LOG_LEVEL_NOTIFY,LOGMESSAGE)
#define ERRORLOG(LOGMESSAGE)  LOGOUT(LOG_LEVEL_ERROR,LOGMESSAGE)


class Logger
{
public:
	Logger();
	virtual ~Logger();

	void Create(const std::string& logfilename,unsigned int logBufferByte,unsigned int logRotateByte);
	void Flush();
	void Write(const std::string& message);

	void SetLogLevel(LOG_LEVEL level)
	{
		this->level = level;
	}
	LOG_LEVEL getLevel() const
	{
		return this->level;
	}
	void SetCanStdout(bool canStdout)
	{
		this->canStdout = canStdout;
	}

	

	std::string getFilename() const
	{
		return this->filename;
	}
	std::string getFilenameBack() const
	{
		return this->filename + ".back";
	}
	
	std::string tail(int lines);
	void rotate();


private:
	void WriteLow(const std::string& log);
	//ローテートの実装部分(private) 必ず lockして読んでね
	void rotateLow();

private:
	FILE* fp;
	std::vector<char> fp_buffer; //だいたい65535bytesぐらい？
	LOG_LEVEL level;
	bool canStdout;
	unsigned long rotateSize;
	std::string filename;

	mutable boost::mutex lock;
};
