﻿#pragma once

#ifdef _MSC_VER // This check can be removed if you only build for Windows
#include <Winsock2.h>
#include <mswsock.h>

#include <windows.h>

#pragma warning (push)
#pragma warning (disable : 4005)
#include <intsafe.h>
#include <stdint.h>
#pragma warning (push)
#pragma warning (default : 4005)
#include <atlbase.h>

#ifdef _DEBUG
	#define _CRTDBG_MAP_ALLOC
	#include <crtdbg.h>
#endif

#define snprintf _snprintf
#define SecSleep(sec) ::Sleep((sec)*1000)
#define MiriSleep(miri) ::Sleep((miri))

#else
#include <stdint.h>
#include <unistd.h>
#include <sys/sendfile.h>
#include <sys/types.h>
#include <dirent.h>
#define SecSleep(sec) sleep((sec))
#define MiriSleep(miri) usleep((miri)*1000)
typedef unsigned int  LRESULT;
typedef unsigned int  WPARAM;
typedef unsigned int  LPARAM;
typedef unsigned int* HINSTANCE;
typedef unsigned int* HWND;
const int MAX_PATH = 255;

const int WM_CREATE                                             = 0x0001;
const int WM_DESTROY                                    = 0x0002;
const int WM_USER                                               = 0x0400;

#endif

#include <iostream>
#include <string>
#include <map>
#include <vector>
#include <list>
#include <functional>
#include <assert.h>
#include <sstream>
#include <boost/thread.hpp>
#include <boost/asio.hpp>

template<typename _INT> static const std::string num2str(_INT i)
{
	std::stringstream out;
	out << i;
	return out.str();
}
template<typename _INT> static const std::wstring num2wstr(_INT i)
{
	std::wstringstream out;
	out << i;
	return out.str();
}
static int atoi(const std::string& str)
{
	return atoi(str.c_str());
}
static unsigned int atou(const std::string& str)
{
	char* e;
	return strtoul( str.c_str() ,&e , 10); 
}
static unsigned int atou(const char* str)
{
	char * e;
	return strtoul( str ,&e, 10); 
}

//TRUE を true に
#define Btob(x)	((x) != FALSE)
//true を TRUE に
#define btoB(x)	((DWORD) x)

//メインウィンドウ
class MainWindow;

#include "XLException.h"
#include "windows_encoding.h"
#include "XLDebugUtil.h"

static std::string mapfind(const std::map<std::string,std::string>& stringmap ,const std::string& name ,const std::string& def = "" )
{
	auto it = stringmap.find(name);
	if (it == stringmap.end()) return def;
	return it->second;
}
static std::string mapfind(const std::map<std::string,std::string>* stringmap ,const std::string& name ,const std::string& def = "" )
{
	auto it = stringmap->find(name);
	if (it == stringmap->end()) return def;
	return it->second;
}

