﻿#include "common.h"
#include "MainWindow.h"

#if _MSC_VER
#else
void sigterm_to_log(int sig) 
{
	ERRORLOG("signal:" << sig << "を受信しました。終了させます。");
	MainWindow::m()->Shutdown(EXITCODE_LEVEL_ERROR,true); //exit()
}
#endif

#if _MSC_VER
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPreInst,
                   LPSTR lpszCmdLine, int nCmdShow)
#else
int main(int argc, const char **argv)
#endif
{
	ASSERT_IS_MAIN_THREAD_RUNNING(); //メインスレッドでしか動きません
//	_CrtSetBreakAlloc(24862);
#if _MSC_VER && _DEBUG
	_CrtSetDbgFlag(_CRTDBG_ALLOC_MEM_DF | _CRTDBG_LEAK_CHECK_DF);
	_CrtDumpMemoryLeaks();
#endif

	EXITCODE_LEVEL ret = EXITCODE_LEVEL_ERROR;
	{
		srand( (unsigned int)time(NULL));

		WinSockInit winsockinit;

		MainWindow win;
		if ( win.checkAlreadyRunning()  )
		{//既に動いている
			return 0;
		}

		bool isdebug = true;
#if _MSC_VER
#else
		//終了signalを受け取ったらログに書いて死ぬようにする
		signal(SIGINT|SIGKILL|SIGTERM, sigterm_to_log);
#endif

#ifdef _DEBUG
		{
			win.Create(isdebug);
			ret = win.BlockMessageLoop();
		}
#else
		try
		{
			win.Create(isdebug);
			ret = win.BlockMessageLoop();
		}
		catch(XLException & e)
		{
			win.Shutdown(EXITCODE_LEVEL_ERROR,true); //exit()
		}
		catch(...)
		{
			win.Shutdown(EXITCODE_LEVEL_ERROR,true); //exit()
		}
#endif //_DEBUG
	}

	return (int)ret;
}

